<?php

namespace App\Model\Street;


class ConfigList extends Base
{
    protected $updateTime = false;
    protected $autoTimeStamp = true;
    protected $pk = 'id';
    protected $tableName = 'config_list';
    protected $tableField = [
        'id' => [],
        'config' => ['type' => 'string'],
    ];

    protected $operation = [
        'add' => [
            'field' => '*',
        ],
        'edit' => [
            'field' => '*'
        ],
        'search' => [
            'field' => ['pid', 'server_id', 'ip', 'status', 'forbidden_server_id', 'title']
        ]
    ];

    public function getConfigData($id)
    {
        $next = $this->where(['id' => $id])->field('config')->get();
        if ($next) return $next['config'];
        return '';
    }

    public function updateNextId($id,$idValue){
        $idValue=empty($idValue)?'':$idValue;
        $this->where(['id'=>$id])->update(['config'=>$idValue]);
    }
}
